Rem  APPEND RECORD
Rem
Rem  ISO/IEC 7816-4 section 7.3.4

Sub AppendRecord (S$)

  If LePresent() Then SW1SW2 = swLcLeError : Exit
  If P1 <> 0 Then SW1SW2 = swP1P2Error : Exit

  Call SelectByShortID (P2/8, EFTypeRecord)

  Call CheckAccess (&H04, 0) ' &H04 from Table 18

  Private Type@ : Type@ = Asc (EFDescriptor$) And &H06
  If Type@ = 0 Then SW1SW2 = swFileStructure : Exit

  If Type@ And &H02 Then ' Linear fixed (&H02) or Cyclic (&H06)
    If Lc <> RecordLength() Then SW1SW2 = swLcLeError : Exit
  ElseIf Type@ = &H04 Then ' Linear variable
    If Lc > RecordLength() Then SW1SW2 = swLcLeError : Exit
  End If

  If Type@ <= &H04 Then ' Linear fixed (&H02) or Linear variable (&H04)

    If NumRecords() >= MaxRecords() Then SW1SW2 = swOutOfMemory : Exit
    GoSub ExtendFile

  Else ' Cyclic (&H06)

    Private newest@

    If NumRecords() < MaxRecords() Then
      GoSub ExtendFile
      newest@ = NewestRecord@() + 1
    Else
      Call FindRecord (NumRecords(), 0)
      Put #EFFilenum, , S$
      newest@ = (Seek (#EFFilenum) - EFFCPLen - 1) / Lc
    End If

    Rem  Update NewestRecord (stored under TagProprietary = &H85 in the FCP)
    Call TLVFindValue (EFFilenum, Chr$(TagFCP)+Chr$(TagProprietary))
    Put #EFFilenum, , newest@

  End If

  If FileError <> 0 Then SW1SW2 = swExecutionError : Exit
  Exit Sub

ExtendFile:

  Seek #EFFilenum, Len(#EFFilenum) + 1
  If Type@ = &H04 Then Put #EFFilenum, , Lc
  Put #EFFilenum, , S$
  Return

End Sub