Rem  CREATE FILE
Rem
Rem  ISO/IEC 7816-9 section 9.2

Sub CreateFile (IDATA$)

  If Lc = 0 Or LePresent() Then SW1SW2 = swLcLeError : Exit

  Rem  We don't support creation with default FCP:
  If P1P2 <> 0 Then SW1SW2 = swP1P2Error : Exit

  Rem  Check FCP tag+length
  If Asc(IDATA$) <> TagFCP Or Asc(IDATA$(2)) <> Lc - 2 Then_
    SW1SW2 = swIncorrectParameters : Exit

  Private Tag, Value$

  Rem  Find the File ID
  Tag = TagFileID
  GoSub FindValue
  If Len(Value$) <> 2 Then SW1SW2 = swIncorrectParameters : Exit
  Private FileID
  Private HiFileID@ At FileID : HiFileID@ = Asc(Value$)
  Private LoFileID@ At FileID+1 : LoFileID@ = Asc(Value$(2))
  Private filename$ : filename$ = Right$("000"+Hex$(FileID), 4)

  Rem  Find the File Descriptor Byte
  Tag = TagFileDescriptor
  GoSub FindValue
  If Len(Value$) < 1 Then SW1SW2 = swIncorrectParameters : Exit

  If Asc(Value$) = &H38 Then ' Create DF

    Call CheckAccess (0, &H04) ' &H04 from Table 17

    Rem  Check that the DF name is unique
    Tag = TagDFName
    GoSub FindValue
    If Len(Value$) = 0 Then SW1SW2 = swIncorrectParameters : Exit
    If Len(FindDFName$(Value$)) <> 0 Then SW1SW2 = swDFNameExists : Exit

    MkDir filename$
    If FileError <> 0 Then GoTo ReportError
    ChDir filename$
    filename$ = "FCP"
    Call AddDFName (Value$, CurDir)
    FileID = &HFFFF ' i.e. no current EF

  Else ' Create EF

    Call CheckAccess (0, &H02) ' &H02 from Table 17

    If Dir (filename$) <> 0 Then SW1SW2 = swFileAlreadyExists : Exit
    filename$ = Right$("000"+Hex$(FileID),4)

  End If

  Private filenum : filenum = Open filename$ For Binary Access Write Shared

ReportError:

  Select Case FileError
    Case feFileAlreadyExists : SW1SW2 = swFileAlreadyExists : Exit
    Case feOutOfMemory : SW1SW2 = swOutOfMemory : Exit
    Case Else : If FileError <> 0 Then SW1SW2 = swExecutionError : Exit
  End Select

  Put #filenum, , IDATA$
  Select Case FileError
    Case feWriteError : SW1SW2 = swFileWriteError : Exit
    Case feOutOfMemory : SW1SW2 = swOutOfMemory : Exit
    Case Else : If FileError <> 0 Then SW1SW2 = swExecutionError : Exit
  End Select
  Close #filenum

  CurrentDF = CurDir
  CurrentEF = FileID

  Rem  If write-once transparent EF, write the WrittenMask to file
  Rem  If EF, then Value$ still contains the FileDescriptor:
  If FileID <> &HFFFF And (Asc(Value$) And &H07) = 1 Then
    Call OpenEF (FileID, EFTypeAny)
    If (DataCodingByte() And DCWriteMask) = DCWriteOnce Then
      Seek #EFFilenum, EFFCPLen + (PureDataBytes() + 15) / 8
      Select Case FileError
        Case feOutOfMemory : SW1SW2 = swOutOfMemory : Exit
        Case Else : If FileError <> 0 Then SW1SW2 = swExecutionError : Exit
      End Select
    End If
  End If

  Exit Sub

  FindValue:

    Private P : P = 3 ' Skip FCP tag and FCP length
    Do
      If P = Len(IDATA$) + 1 Then
        Value$ = ""
        Return
      End If
      If P >= Len(IDATA$) - 1 Then SW1SW2 = swIncorrectParameters : Exit
      Private T : T = Asc(IDATA$(P)) : P = P + 1
      Private L : L = Asc(IDATA$(P)) : P = P + 1
      If T = Tag Then
        Value$ = Mid$(IDATA$, P, L)
        Return
      End If
      P = P + L
    Loop

End Sub

