Rem  DISABLE VERIFICATION REQUIREMENT
Rem
Rem  ISO/IEC 7816-4 section 7.5.9
Rem  SCOSTA section 6.2.9

Sub DisableVerificationRequirement (IDATA$)

  Select Case P1
    Case 0 : If Lc = 0 Then SW1SW2 = swLcLeError : Exit
    Case 1 : If Lc <> 0 Then SW1SW2 = swLcLeError : Exit
    Case Else : SW1SW2 = swP1P2Error : Exit
  End Select

  If LePresent() Then SW1SW2 = swLcLeError : Exit

  Call CheckAccess (0, 0)

  Rem  Find the password
  Call FindP2Key (EFIDPassword)

  If (Asc(CurrentKey$) And &H80) <> 0 Then ' V bit set (password valid)
    If Lc = 0 Then ' Previous VERIFY command required
      If SecStat.UserAuthRef <> P2 Then
        SW1SW2 = swSecurityStatus
        Exit
      End If
    Else ' Verification data in IDATA$
      Rem  Check the retry counter in the high nibble of CurrentKey$(2)
      Rem  (this is not mentioned in the specs, but is presumably required)
      Private RetryCounter@ : RetryCounter@ = Asc(CurrentKey$(2))
      If RetryCounter@ < &H10 Then SW1SW2 = swKeyDisabled : Exit

      If RetryCounter@ < &HF0 Then
        Rem  Decrement the retry counter before checking the password,
        Rem  to prevent current-based attacks
        RetryCounter@ = RetryCounter@ - &H10
        Put #CurrentKey.filenum@, CurrentKey.filepos+1, RetryCounter@
        If FileError <> 0 Then SW1SW2 = swFileWriteError : Exit
      End If

      Rem  Check the password
      If IDATA$ <> Mid$(CurrentKey$, 3) Then_
        SW1SW2 = swRetriesRemaining + RetryCounter@ / 16 : Exit

      If RetryCounter@ < &HF0 Then
        Rem  Reset the Retry Counter
        RetryCounter@ = &H11 * (RetryCounter@ And &H0F)
        Put #CurrentKey.filenum@, CurrentKey.filepos+1, RetryCounter@
        If FileError <> 0 Then SW1SW2 = swFileWriteError : Exit
      End If
    End If

    Rem  Clear the V bit
    CurrentKey$ = Chr$(Asc(CurrentKey$) And &H7F)
    Put #CurrentKey.filenum@, CurrentKey.filepos, CurrentKey$
    If FileError <> 0 Then SW1SW2 = swFileWriteError : Exit
  End If

End Sub
