Rem  ENABLE VERIFICATION REQUIREMENT
Rem
Rem  ISO/IEC 7816-4 section 7.5.8
Rem  SCOSTA section 6.2.8

Sub EnableVerificationRequirement (IDATA$)

  Select Case P1
    Case 0 : If Lc = 0 Then SW1SW2 = swLcLeError : Exit
    Case 1 : If Lc <> 0 Then SW1SW2 = swLcLeError : Exit
    Case Else : SW1SW2 = swP1P2Error : Exit
  End Select

  If LePresent() Then SW1SW2 = swLcLeError : Exit

  Call CheckAccess (0, 0)

  Rem  Find the password
  Call FindP2Key (EFIDPassword)

  Private NewKey$ : NewKey$ = CurrentKey$

  If (Asc(CurrentKey$) And &H80) = 0 Then ' V bit clear (password invalid)
    Rem  In this case, IDATA$ may contain a replacement password
    If Lc = Len(CurrentKey$) - 2 Then
      Mid$(NewKey$, 3) = IDATA$
    ElseIf Lc <> 0 Then
      SW1SW2 = swLcLeError : Exit
    End If
  ElseIf Lc <> 0 Then
    SW1SW2 = swLcLeError : Exit
  End If

  Rem  Set the V bit
  NewKey$(1) = Chr$(Asc(NewKey$) Or &H80)

  If NewKey$ <> CurrentKey$ Then
    Put #CurrentKey.filenum@, CurrentKey.filepos, NewKey$
    If FileError <> 0 Then SW1SW2 = swFileWriteError : Exit
  End If

End Sub
