Rem  INTERNAL AUTHENTICATE
Rem
Rem  ISO/IEC 7816-4 section 7.5.1
Rem  SCOSTA section 6.2.2

Sub InternalAuthenticate (IDATA$)

  If P1 > 1 Then SW1SW2 = swConditionsOfUse : Exit
  If Not LePresent() Or Lc < 8 Or (Lc And &H07) <> 0 Then_
    SW1SW2 = swLcLeError : Exit

  Call CheckAccess (0, 0)

  Rem  Find the key
  Call FindP2Key (EFIDKey)

  Rem  Check that it's valid
  If (Asc(CurrentKey$) And &H80) = 0 Then_ ' V bit clear (key invalid)
    SW1SW2 = swReferenceDataInvalidated : Exit

  Rem  Check that it can be used for Internal Authentication
  Private KeyType@ : KeyType@ = Asc(CurrentKey$(2))
  If (KeyType@ And &H02) = 0 Then SW1SW2 = swConditionsOfUse : Exit

  Rem  Get the index of the Usage Counter
  Private I = 3
  If KeyType@ And &H20 Then I = I + 2
  If KeyType@ And &H10 Then I = I + 2

  Rem  Check that the Usage Counter is non-zero
  Private UsageCounter&
  Private UsageCounter$ As String*2 At UsageCounter&+2
  UsageCounter$ = Mid$(CurrentKey$, I, 2)
  If UsageCounter& = 0 Then SW1SW2 = swKeyDisabled : Exit

  If UsageCounter& <> &HFFFF Then
    Rem  Decrement it
    UsageCounter& = UsageCounter& - 1
    Put #CurrentKey.filenum@, CurrentKey.filepos+I-1, UsageCounter$
  End If

  Rem  Get the index of the Algorithm Reference
  I = I + 2 ' Skip Usage Counter
  If KeyType@ And &H01 Then I = I + 1

  Rem  In this version, 3DES is the only algorithm allowed
  If Asc(CurrentKey$(I)) > 1 Then SW1SW2 = swConditionsOfUse : Exit

  CurrentKey$ = Mid$(CurrentKey$, I+1)
  If Len(CurrentKey$) <> 16 Then SW1SW2 = swConditionsOfUse : Exit

  Rem  Encrypt IDATA$ using 3DES in CBC mode
  Call Encrypt3DESCBC (IDATA$, CurrentKey$)

End Sub
