Rem  MANAGE CHANNEL
Rem
Rem  ISO/IEC 7816-4 section 7.1.2

Sub ManageChannel (IDATA$)

  If Lc <> 0 Then SW1SW2 = swLcLeError : Exit

  Private Channel@

  Select Case P1

    Case &H00 ' Open a Channel

      If P2 = 0 Then ' Assign a Channel number

        If Not LePresent() Then SW1SW2 = swLcLeError : Exit
        For Channel@ = 1 To MaxChannel
          If Not ChannelOpen(Channel@) Then Exit For
        Next Channel@

        If Channel@ > MaxChannel Then SW1SW2 = swAllChannelsInUse : Exit
        IDATA$ = Chr$(Channel@)

      Else ' Open a specific Channel

        If LePresent() Then SW1SW2 = swLcLeError : Exit
        If P2 < 1 Or P2 > 3 Then SW1SW2 = swP1P2Error : Exit
        If P2 > MaxChannel Then SW1SW2 = swChannelNotSupported : Exit
        If ChannelOpen(P2) Then SW1SW2 = swChannelInUse : Exit
        Channel@ = P2

      End If

      ChannelOpen(Channel@) = True
      CurrentDF(Channel@) = CurrentDF(CurrentChannel@)

    Case &H80 ' Close a Channel

      If P2 < 1 Or P2 > 3 Then SW1SW2 = swP1P2Error : Exit
      If P2 > MaxChannel Then SW1SW2 = swChannelNotSupported : Exit
      If Not ChannelOpen(P2) Then SW1SW2 = swChannelNotOpen : Exit

      Call CloseChannel(P2)

    Case Else : SW1SW2 = swP1P2Error : Exit

  End Select
    
End Sub

Sub CloseChannel (Channel@)
  CurrentDF(Channel@) = ""
  CurrentEF(Channel@) = &HFFFF
  ChannelOpen(Channel@) = False
End Sub
