Rem  RESET RETRY COUNTER
Rem
Rem  ISO/IEC 7816-4 section 7.5.7
Rem  SCOSTA section 6.2.11

Sub ResetRetryCounter (IDATA$)

  If LePresent() Then SW1SW2 = swLcLeError : Exit

  Call CheckAccess (0, 0)

#If 0
  Rem  The spec says that a preceding VERIFY command is needed.
  Rem  But this is impossible, because the password is disabled...
  If SecStat.UserAuthRef <> P2 Then SW1SW2 = swSecurityStatus : Exit
#EndIf

  Rem  Find the password
  Call FindP2Key (EFIDPassword)
  Private RetryCounter@
  RetryCounter@ = Asc(CurrentKey$(2)) And &H0F ' Reset value

  Select Case P1

    Rem  Cases 00 and 02 are not required (see SCOSTA Errata)
    Case &H00, &H02 : SW1SW2 = swFunctionNotSupported : Exit

    Case &H01
      If Lc <> 1 Then SW1SW2 = swLcInconsistent : Exit
      Private NewCounter@ : NewCounter@ = Asc(IDATA$)
      If NewCounter@ > RetryCounter@ Then NewCounter@ = RetryCounter@
      RetryCounter@ = 16*NewCounter@ + RetryCounter@

    Case &H03
      If Lc <> 0 Then SW1SW2 = swLcInconsistent : Exit
      RetryCounter@ = &H11 * RetryCounter@

    Case Else : SW1SW2 = swP1P2Error : Exit

  End Select

  If RetryCounter@ <> Asc(CurrentKey$(2)) Then
    Put #CurrentKey.filenum@, CurrentKey.filepos+1, RetryCounter@
    If FileError <> 0 Then SW1SW2 = swFileWriteError : Exit
  End If

End Sub
