Rem  SHORTID.BAS
Rem
Rem  Selection by Short EF Identifier

Rem  Sub SelectByShortID (ShortID@, Type@)
Rem
Rem  Find the EF specfied by the Short EF Identifier ShortID@.
Rem  Type@ is EFTypeTransparent, EFTypeRecord, or EFTypeAny

Sub SelectByShortID (ShortID@, Type@)

  If ShortID@ = 31 Then SW1SW2 = swIncorrectParameters : Exit

  If ShortID@ = 0 Then

    Call OpenEF (CurrentEF, Type@)

  Else

    Private filename$
    filename$ = FindShortID$ (ShortID@, CurrentDF+"\")
    If Len(filename$) = 0 Then SW1SW2 = swFileNotFound : Exit

    Call SetCurrentEF (filename$, Type@)
  End If

End Sub

Rem  Function FindShortID (ShortID@, dir$)
Rem
Rem  Look for an EF with the given ShortID in the given directory.
Rem  Returns the filename if found.

Function FindShortID$ (ShortID@, dir$)

  Rem  First look in the DF
  Private filenum : filenum = Open "FCP" For Binary Access Read Shared
  If FileError = 0 Then

    Rem  Seek to tag TagShortIDList = &HA2
    Private Length
    Length = TLVFindValue (filenum, Chr$(TagFCP)+Chr$(TagShortIDList))
   
    Rem  Read the (ShortID, path$) pairs
    While Length > 3
      If Length <= 0 Then Exit While
   
      Private TL As SimpleTL
      Get #filenum, , TL
      If FileError <> 0 Or TL.tag@ <> TagShortID Or TL.len@ <> 1 Then Exit While
      Private val@ : Get #filenum, , val@
      Get #filenum, , TL
      If FileError <> 0 Then Exit While

      If val@ = ShortID@ Then
        If FileError <> 0 Or TL.tag@ <> TagPath Then Exit While
        Private path$ : Get #filenum, , path$, TL.len@
        If FileError <> 0 Then Exit While
        Close #filenum
        FindShortID$ = FilenameFromPath$ (path$)
        Exit Function
      End If
      Seek #filenum, Seek(#filenum) + TL.len@
      If FileError <> 0 Then Exit While
      Length = Length - TL.len@ - 2
    Wend

    Close filenum

  End If

  FileError = 0

  Rem  Next look in the individual EF's

  Private nFiles : nFiles = Dir (dir$+"????")
  Private I : For I = 1 To nFiles
    FindShortID$ = Dir(dir$+"????", I)
    Private S : S = ReadShortID (dir$+FindShortID$)
    If S = ShortID@ Then FindShortID$ = dir$ + FindShortID$ : Exit Function
  Next I

  Rem  Finally look in the bottom 5 bits of the FileID's

  For I = 1 To nFiles
    FindShortID$ = Dir(dir$+"????", I)
    If (ValH(FindShortID$) And &H1F) = ShortID@ Then_
      FindShortID$ = dir$ + FindShortID$ : Exit Function
  Next I

  FindShortID$ = ""

End Function

Rem  Function ReadShortID (filename$)
Rem
Rem  If the file starts with an FCP that contains a ShortID field,
Rem  this function returns the ShortID. Otherwise it returns 0.

Function ReadShortID (filename$)
  Private filenum : filenum = Open filename$ For Binary Access Read Shared
  If FileError <> 0 Then FileError = 0 : Exit Function
  Private value$
  Call TLVReadValue (filenum, Chr$(TagFCP)+Chr$(TagShortID), value$)
  Close filenum
  If Len(value$) = 1 Then
    ReadShortID = Asc(Value$)
    If ReadShortID > 30 Then ReadShortID = 0
  End If
End Function
