Rem  VERIFY
Rem
Rem  ISO/IEC 7816-4 section 7.5.5
Rem  SCOSTA section 6.2.1

Sub Verify (IDATA$)

  If LePresent() Then SW1SW2 = swLcLeError : Exit

  ResponseLength = 0
  SecStat.UserAuthRef = &HFF

  If P1 <> 0 Then SW1SW2 = swP1P2Error : Exit

  Rem  Find the password
  Call FindP2Key (EFIDPassword)

  Rem  Check that it's valid
  If (Asc(CurrentKey$) And &H80) = 0 Then ' V bit clear (password invalid)
    If Lc <> 0 Then SW1SW2 = swReferenceDataInvalidated
    Exit
  End If

  Rem  Check the retry counter in the high nibble of CurrentKey$(2)
  Private RetryCounter@ : RetryCounter@ = Asc(CurrentKey$(2))
  If RetryCounter@ < &H10 Then SW1SW2 = swKeyDisabled : Exit

  If Lc = 0 Then ' Just return the retry count
    SW1SW2 = swRetriesRemaining + RetryCounter@ / 16
    Exit
  End If

  If RetryCounter@ < &HF0 Then
    Rem  Decrement the retry counter before checking the password,
    Rem  to prevent current-based attacks
    RetryCounter@ = RetryCounter@ - &H10
    Put #CurrentKey.filenum@, CurrentKey.filepos+1, RetryCounter@
    If FileError <> 0 Then SW1SW2 = swFileWriteError : Exit
  End If

  Rem  Check the password
  If IDATA$ = Mid$(CurrentKey$, 3) Then ' Verification successful
    If RetryCounter@ < &HF0 Then
      Rem  Reset the Retry Counter
      RetryCounter@ = &H11 * (RetryCounter@ And &H0F)
      Put #CurrentKey.filenum@, CurrentKey.filepos+1, RetryCounter@
      If FileError <> 0 Then SW1SW2 = swFileWriteError : Exit
    End If

    SecStat.UserAuthRef = P2 ' The result of all this

  Else ' Verification failed
    SW1SW2 = swRetriesRemaining + RetryCounter@ / 16
  End If

End Sub
